<template>
  <main>
    <v-container grid-list-lg>
      <v-layout row>
        <!-- Loader -->
        <v-flex sm12 class="text-sm-center" v-if="loading">
          <v-progress-circular indeterminate class="primary--text"></v-progress-circular>
        </v-flex>
        <!-- After load -->
        <template v-else>
          <v-flex sm6>
            <v-card>
              <v-card-title primary-title class="pb-0">
                <div>
                  <div class="headline">Game Details</div>
                  <!-- <div class="grey--text">{{$timestamp(data.gameInfo.created_at, 'LLL')}}</div> -->
                </div>
              </v-card-title>
              <v-card-text>
                <v-select label="Game Type" v-model="data.gameDetails['game_type']" :items="$store.state.gameTypes" @change="update(`game_details/${data.gameDetails.key}/game_type`, 'gameDetails')"></v-select>
                <v-switch :label="`Team Game: ${data.gameDetails['is_team'] ? 'Yes': 'No'}`" v-model="data.gameDetails['is_team']" :true-value="1" :false-value="0" @change="update(`game_details/${data.gameDetails.key}/is_team`, 'gameDetails')"></v-switch>
              </v-card-text>
            </v-card>
          </v-flex>

          <v-flex sm6>
            <v-card>
              <v-card-title primary-title class="pb-0">
                <div>
                  <div class="headline">Set winner</div>
                  <!-- <div class="grey--text">{{$timestamp(data.gameInfo.created_at, 'LLL')}}</div> -->
                </div>
              </v-card-title>
              <v-card-text style="height: 128px;">
                <v-select label="Winner" v-model="winner" :items="teams" :disabled="data.gameDetails.status === 4"></v-select>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn flat primary @click="setWinner" :disabled="data.gameDetails.status === 4">Set Winner</v-btn>
              </v-card-actions>
            </v-card>
          </v-flex>

        </template>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  export default {
    name: 'game',
    data () {
      return {
        loading: true,
        data: {},
        teams: [
          {text: 'Team 1', value: 1},
          {text: 'Team 2', value: 2}
        ],
        winner: null
      }
    },
    methods: {
      loadData () {
        // 01: Get `game_id` from game_details WHERE id = $route.params.id
        this.$database.ref(`game_details/${this.$route.params.id}`).once('value').then(snapshot => {
          let gameDetails = snapshot.val()
          gameDetails.key = snapshot.key
          return gameDetails
        }).then(gameDetails => {
          Promise.all([
            // 02: Get more game info from `games` WHERE id = `game_details.game_id`
            this.$database.ref(`games/${gameDetails.game_id}`).once('value'),
            // 03: Get team members of `gameDetails.teams[0]` WHERE `team_id` = `gameDetails.teams[0]`
            this.$database.ref(`team_user`).orderByChild('team_id').equalTo(gameDetails.teams[0]).once('value'),
            // 04: Get team members of `gameDetails.teams[1]` WHERE `team_id` = `gameDetails.teams[1]`
            this.$database.ref(`team_user`).orderByChild('team_id').equalTo(gameDetails.teams[1]).once('value')
          ]).then(snapshots => {
            // 05: After 2, 3, 4, returns a result WHERE result is an array containing [more game info, team 1 members, team 2 members]
            this.loading = false
            this.data = {
              gameDetails,
              gameInfo: snapshots[0].val(),
              team1: snapshots[1].val(),
              team2: snapshots[2].val()
            }
          }).catch(error => console.log('AN ERROR OCCURED:', error))
        })
      },
      update (address, ref) {
        setTimeout(() => {
          let prop = address.split('/')
          prop = prop[prop.length - 1]

          let value = this.data[ref][prop]

          this.$database.ref(address).set(value)

          console.log(address, value)
        }, 300)
      },
      setWinner () {
        let winningMembers = this.data[`team${this.winner}`]
        let losingMembers = (this.winner === 2) ? this.data['team1'] : this.data['team2']
        let threads = []

        Object.keys(winningMembers).forEach(index => {
          let userId = winningMembers[index].user_id
          threads.push(this.$database.ref('win_lose').push({
            game_detail: this.data.gameDetails.key,
            status: 'win',
            uid: userId
          }))
        })

        Object.keys(losingMembers).forEach(index => {
          let userId = losingMembers[index].user_id
          threads.push(this.$database.ref('win_lose').push({
            game_detail: this.data.gameDetails.key,
            status: 'lose',
            uid: userId
          }))
        })

        Promise.all(threads).then(snapshots => {
          Promise.all([
            this.$database.ref(`game_details/${this.data.gameDetails.key}/status`).set(4),
            this.$database.ref(`games/${this.data.gameDetails.game_id}/status`).set(4)
          ]).then(() => {
            this.loadData()
          })
        }).catch(error => console.log('AN ERROR OCCURED:', error))
      }
    },
    created () {
      this.loadData()
    }
  }
</script>
